.\"	$NetBSD: uu.4,v 1.10 2003/05/03 18:10:40 wiz Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)uu.4	8.1 (Berkeley) 6/5/93
.\"
.Dd June 5, 1993
.Dt UU 4 vax
.Os
.Sh NAME
.Nm uu
.Nd
.Tn TU-58 Ns / Ns Tn DECtape II UNIBUS
cassette interface
.Sh SYNOPSIS
.Cd "options UUDMA"
.Cd "uu0 at uba0 csr 0176500 vector uurintr uuxintr"
.Sh DESCRIPTION
NOTE: This driver has not been ported from
.Bx 4.4
yet.
.Pp
The
.Nm uu
device provides access to dual
.Tn DEC
.Tn TU-58
tape cartridge drives
connected to the
.Tn UNIBUS
via a
.Tn DL-11W
interface module.
.Pp
The interface supports only block
.Tn I/O
to the
.Tn TU-58
cassettes (see
.Xr physio 4 ) .
The drives are normally manipulated with the
.Xr arff 8
program using the ``m'' and ``f'' options.
.Pp
The driver provides for an optional write and verify
(read after write) mode that is activated by specifying the
``a'' device.
.Pp
The
.Tn TU-58
is treated as a single device by the system even
though it has two separate drives,
.Sq Li uu0
and
.Sq Li uu1 .
If there is
more than one
.Tn TU-58
unit on a system, the extra drives
are named
.Sq Li uu2 ,
.Sq Li uu3
etc.
.Sh NOTES
Assembly language code to assist the driver in handling
the receipt of data (using a pseudo-DMA approach) should
be included when using this driver; specify
.Sq Li options UUDMA
in the configuration file.
.Sh FILES
.Bl -tag -width /dev/uu?a -compact
.It Pa /dev/uu?
.It Pa /dev/uu?a
.El
.Sh DIAGNOSTICS
.Bl -diag
.It uu%d: no bp, active %d.
A transmission complete interrupt was received with no outstanding
.Tn I/O
request. This indicates a hardware problem.
.Pp
.It uu%d protocol error, state=%s, op=%x, cnt=%d, block=%d.
The driver entered an illegal state.  The information printed
indicates the illegal state, the
operation currently being executed,
the
.Tn I/O
count, and the block number on the cassette.
.Pp
.It uu%d: break received, transfer restarted.
The
.Tn TU-58
was sending a continuous break signal and had
to be reset. This may indicate a hardware problem, but
the driver will attempt to recover from the error.
.Pp
.It uu%d receive state error, state=%s, byte=%x.
The driver entered an illegal state in the receiver finite
state machine.  The state is shown along with the control
byte of the received packet.
.Pp
.It uu%d: read stalled.
A timer watching the controller detected no interrupt for
an extended period while an operation was outstanding.
This usually indicates that one or more receiver interrupts
were lost and the transfer is restarted.
.Pp
.It uu%d: hard error bn%d, pk_mod %o.
The device returned a status code indicating a hard error. The
actual error code is shown in octal. No retries are attempted
by the driver.
.El
.Sh ERRORS
The following errors may be returned:
.Bl -tag -width [ENXIO]
.It Bq Er ENXIO
Nonexistent drive (on open);
offset is too large or bad (undefined)
.Xr ioctl 2
code.
.It Bq Er EIO
Open failed, the device could not be reset.
.It Bq Er EBUSY
Drive in use.
.El
.Sh SEE ALSO
.Xr tu 4 ,
.Xr arff 8
.Sh HISTORY
The
.Nm
driver appeared in
.Bx 4.2 .
